{******************************************************************************}
{ Jazarsoft Virtual Desktop Demo                                               }
{******************************************************************************}
{                                                                              }
{ VERSION      : 1.0                                                           }
{ AUTHOR       : James Azarja                                                  }
{ CREATED      : 10 July 2000                                                  }
{ WEBSITE      : http://www.jazarsoft.cjb.net/                                 }
{ SUPPORT      : support@jazarsoft.cjb.net                                     }
{ BUG-REPORT   : bugreport@jazarsoft.cjb.net                                   }
{ COMMENT      : comment@jazarsoft.cjb.net                                     }
{ LEGAL        : Copyright (C) 2000 Jazarsoft.                                 }
{                                                                              }
{******************************************************************************}
{ NOTE         :                                                               }
{                                                                              }
{ This code may be used and modified by anyone so long as  this header and     }
{ copyright  information remains intact.                                       }
{                                                                              }
{ The code is provided "as-is" and without warranty of any kind,               }
{ expressed, implied or otherwise, including and without limitation, any       }
{ warranty of merchantability or fitness for a  particular purpose.           }
{                                                                              }
{ In no event shall the author be liable for any special, incidental,          }
{ indirect or consequential damages whatsoever (including, without             }
{ limitation, damages for loss of profits, business interruption, loss         }
{ of information, or any other loss), whether or not advised of the            }
{ possibility of damage, and on any theory of liability, arising out of        }
{ or in connection with the use or inability to use this software.           }
{                                                                              }
{******************************************************************************}
{ IMPORTANT NOTES                                                              }
{                                                                              }
{ Please use FormEx (http://www.jazarsoft.cjb.net/) or another Delphi Form     }
{ Extension that support StayOnTop Feature on Virtual Desktop Manager 	       }
{ to keep the program always show on Top.                                      }
{                                                                              }
{******************************************************************************}

unit uVD;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  VirtuaDesktop, StdCtrls,  ComCtrls, ToolWin, ImgList, ExtCtrls, FormExtension,
  NSKComp;

type
  TfrmVirtuaDesktop = class(TForm)
    VirtuaDesktop: TVirtuaDesktop;
    TemplateIcon: TImageList;
    tbDesktopSelect: TToolBar;
    IconList: TImageList;
    HotIconList: TImageList;
    FormEx: TFormExtension;
    NSK: TNSK;
    procedure FormCreate(Sender: TObject);
    procedure ToolButtonClick(Sender: TObject);
    procedure tbDesktopSelectResize(Sender: TObject);
  private
  public
    Procedure Start;
    Procedure Stop;
    procedure SwitchTo(DesktopIndex:Integer);
  end;

var
  frmVirtuaDesktop: TfrmVirtuaDesktop;

implementation

{$R *.DFM}


procedure TfrmVirtuaDesktop.FormCreate(Sender: TObject);
var Counter:Integer;
    Buffer : tBitmap;
    Str:String;
begin
 For Counter:=1 to VirtuaDesktop.NumberOfDesktop do
 Begin
  Str:=Inttostr(Counter);
  Buffer:=tBitmap.Create;

  TemplateIcon.GetBitmap(0,Buffer);
  Buffer.Canvas.Font.Name:='Arial';
  Buffer.Canvas.Font.Size:=9;
  Buffer.Canvas.Font.color:=clWhite;
  SetBkMode(Buffer.Canvas.Handle,TRANSPARENT);
  Buffer.Canvas.TextOut(((Buffer.Width - Buffer.canvas.TextWidth(Str)) div 2),
  ((Buffer.Height - Buffer.canvas.TextHeight(Str)) div 2),Str);
  IconList.AddMasked(Buffer,Buffer.Canvas.Pixels[0,0]);
  
  TemplateIcon.GetBitmap(1,Buffer);
  Buffer.Canvas.Font.Name:='Arial';
  Buffer.Canvas.Font.Size:=9;
  Buffer.Canvas.Font.color:=clWhite;
  SetBkMode(Buffer.Canvas.Handle,TRANSPARENT);
  Buffer.Canvas.TextOut(((Buffer.Width - Buffer.canvas.TextWidth(Str)) div 2),
  ((Buffer.Height - Buffer.canvas.TextHeight(Str)) div 2),Str);
  IconList.AddMasked(Buffer,Buffer.Canvas.Pixels[0,0]);
  Buffer.free;
 End;

 For Counter:=VirtuaDesktop.NumberOfDesktop downto 1 do
 Begin
  Str:=Inttostr(Counter);

  With tToolButton.Create(tbDesktopSelect) do
  Begin
   Parent := tbDesktopSelect;
   Caption := Str;
   Style := tbsButton;
   if Counter=1 then
   ImageIndex:=(Counter-1)*2+1 else
   ImageIndex:=(Counter-1)*2;
   Hint:='Switch to Desktop #'+Str;
   ShowHint:=True;
   Tag:=Counter;
   OnClick:=ToolButtonClick;
  End;
 End;

end;

procedure TfrmVirtuaDesktop.ToolButtonClick(Sender: TObject);
begin
 tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex:=
  tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex-1;

 VirtuaDesktop.CurrentDesktop:=(Sender as tToolButton).Tag;

 tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex:=
  tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex+1;
end;

procedure TfrmVirtuaDesktop.Start;
Begin
 VirtuaDesktop.Start;
 VirtuaDesktop.ExcludeWindow.Add(InttoHex(Handle,8));
End;

procedure TfrmVirtuaDesktop.Stop;
Begin
 VirtuaDesktop.Stop;
End;

procedure TfrmVirtuaDesktop.SwitchTo(DesktopIndex:Integer);
Begin
 tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex:=
  tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex-1;

 VirtuaDesktop.CurrentDesktop:=DesktopIndex;

 tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex:=
  tbDesktopSelect.Buttons[VirtuaDesktop.CurrentDesktop-1].ImageIndex+1;
End;

procedure TfrmVirtuaDesktop.tbDesktopSelectResize(Sender: TObject);
begin
 ClientWidth:=tbDesktopSelect.Width;
 ClientHeight:=tbDesktopSelect.Height;
end;

end.
